# Feed-Analyzer 0.1.0 - very short documentation

## Usage

- Shorter version of this section is in the ``--help`` program option
- All of the configuration about feeds and keywords is stored in config TOML file, see **configuration**
- Config can be specified using the ``-c`` option
- ``-d`` Outputs additional debug info on program start
- ``-dd`` same as above but also prints stack trace on critical errors

### Filtering

- See **configuration structure** for explanation of used terminology
- Anything without '-' is considered filter that you want to be applied to the feeds
- If you want to filter all of the feeds using all of their filters, you don't have to specify anything
- First you specify the section you want feeds downloaded for
  - If you specify just section, all of the filter groups will be applied to all feeds in section
  - if you want to specify more sections, you just separate them with ' ' space
- If you wan't to filter just specific groups of keywords, you put them after the section name separating them using ':'
- For every other group, only dot '.' is used
  - Example: ``section:group1`` - Apply keywords from ``group1`` to all feeds from ``section``
  - Example: ``section:group1.group2.group3`` - Apply keywords from group1, group2 and group3 to all feeds from section
  - Example: ``section`` - Applies all groups to all feeds from section ``section``
  - Example: ``section1 section2`` - Applies all groups from ``section1`` to all feeds from ``section1`` THEN Applies all groups
             from ``section2`` to all feeds from ``section2``
- Note that when using ``section:group1.group2`` all items that match ``group1`` OR ``group2`` are printed - that is, if one item
  is matched multipple times it'll be printed multiple times
- __All sections and group names are case sensitive!!__
- If there is a spelling error in a group name or the group does not exist, the group is ignored
- If there is a spelling error in a section name or the section does not exist __an exception is thrown and program exits!__

## Configuration

- Configuration is done in TOML 0.4.0 format
  - This is still pretty limiting, the config structure will change for sure with upgrade to 1.0.0
- Basically more advanced .ini
- Example file is included in ``doc/`` dir and in the ``prebuilt/`` dir so it could be used directly without specifying the config
  file
- The program looks for config in several default hardcoded places
  - ``./feeds.toml``, ``~/.config/feed-analyzer/config.toml`` and ``~/.feed-config.toml``
  - This is also the priority in which they are used - with the local dir config being the highest
- But these can be overriden with the ``-c`` arg, see **Usage**
- Configuration is case sensitive!

### Structure

- There are two types of sections
  - [Global] - For program behavior config
  - [Anything else] - For specifying feeds and their filter groups
- There is more info in example config

#### Global section

- Currently __nothing__ works in here, but it will contain anything for customizing the program:
  - Global keywords
  - Path to the .json database (this will keep track of already read items)
  - More options for coloring text
  - ..Much more..

#### Other sections

- Names can be anything you want, just remember that you will have to specify that name when calling the program if you
  want to filter just that particular section
- Sources are specified using the ``Sources`` vector, they can contain as many items you want
  - keep in mind that all feeds are always downloaded and filtered - this may take mroe time
  - Always give direct url for the feed (usually ends with .xml or .rss)
  - If you want to be sure it's the correct url just open it in browser and it should give you the xml content
  - If some feeds fail to download, try to open them in browser to see if it's not just broken url
- Every section has to contain [(section name).KeyWords] subsection so the program can separate sources from filters
  - Every such subsection can have vektor of keywords you want to filter - these are called ``groups``
  - You can specify as many groups as you want with any names you want

### TOML Format notes

- Section is specified by putting it's name into square brackets []
- Subsection is section.subsection name in square brackets
- Vektor is list of values separated by comma in square brackets [] -> something = ["this", "is", "a", "vektor"]
- New lines inside vektor are allowed -> vekt = ["this",
	                                             "is",
												 "fine"]
- For example, check the included config
- For more [info about toml ver 0.4.0](https://toml.io/en/v0.4.0)
